-- 下载奖励
Lua_DownLoadRewardWindow = class("Lua_DownLoadRewardWindow", Lua_Window);
function Lua_DownLoadRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DownLoadRewardWindow";
	self.skinName = "DownLoadRewardWindow_skin";
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -478;
	self.winBgPath = "/images/downloadreward/xui_xzjl_window_2.png";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_DownLoadRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.progressBar.typeValue = 3;
	self.progressBar.fillMethodValue = 0;
	self.progressBar.fillOrigin = 0;
	-- self.progressBar:createSlider("common_altas_1", "ui_xzjl_progress_001_m", -19, 0);
	self.progressBar:setMouseEnable(false);
	self.progressBar:setMaxValue(1000);

	local rewardId = Lua_CommonUtil.getCommonConfig("download_rewardId", 1, 10201);
	local rewardVo = Lua_RewardConfigData.getConfigDataById(rewardId);
	local len = rewardVo.rewardsArr:getSize();
	local posX = len > 4 and 0 or (512 - len * 128) / 2;
	self.rewardList = Lua_DragList.new(self.content, 512, 116, Lua_AxisDefine.Horizontal);
	self.rewardList.canDrag = len > 4;
	self.rewardList:setListCell(Lua_DownLoadRewardItem, 128, 116, 1);
	self.rewardList:setArrayData(rewardVo.rewardsArr);
	self.rewardList:setLocation(posX, -210, 0);

	self.switchbtn:addClickFuntion(self, self.onSwitchClick);
	self.getbtn:addClickFuntion(self, self.getRewardClick);
	self:renewDownLoadState();
end

function Lua_DownLoadRewardWindow:renewDownLoadState()
	local isLoading = UpdateResManager.getInstance().isLoading;
	if isLoading then
		self.switchbtn:setLangValue(130304); -- 暂停下载
		Lua_CommonUtil.addTimer("PauseDown", 1, self, self.onDownLoading);
	else
		self.switchbtn:setLangValue(130303); -- 继续下载
		Lua_CommonUtil.removeTimer(self, self.onDownLoading); 
	end
	self:onDownLoading();
end

function Lua_DownLoadRewardWindow:onDownLoading()
	local curProgress = UpdateResManager.getInstance().currentProgress * 10;
	if curProgress >= 1000 then
		Lua_CommonUtil.removeTimer(self, self.onDownLoading);
		self.switchbtn:setLangValue(130305); -- 下载完成
		self.switchbtn:setStyle(3);
		self.getbtn:setStyle(1);
		self.progressBar:setValue(1000);
		self:showRedDot(true);
	else
		self.switchbtn:setStyle(1);
		self.getbtn:setStyle(3);
		self.progressBar:setValue(curProgress);
		self:showRedDot(false);
	end
	self.progresstips.text = LanUtil.formateStr(130302, string.format("%.2f", curProgress / 10));
end

function Lua_DownLoadRewardWindow:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(251, -336, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_DownLoadRewardWindow:onSwitchClick(go)
	local curProgress = UpdateResManager.getInstance().currentProgress * 10;
	if curProgress >= 1000 then
		OperateAlert.showLangValue(130306);
		return;
	end

	local isLoading = UpdateResManager.getInstance().isLoading;
	if isLoading then
		UpdateResManager.getInstance():stopLoad();
	else
		UpdateResManager.getInstance():startLoad();
	end
	self:renewDownLoadState();
end

function Lua_DownLoadRewardWindow:getRewardClick(go)
	local curProgress = UpdateResManager.getInstance().currentProgress * 10;
	if curProgress < 1000 then
		OperateAlert.showLangValue(130307);
		return;
	end

	local hasGotReward = DataCenter.downLoadRewardData.downLoadState;
	if hasGotReward == 1 then -- 已领取
		OperateAlert.showLangValue(130301);
	else
		Lua_ProxyManager.getProxy("Lua_DownLoadRewardProxy"):sDownLoadRewardInfo();
	end
	Lua_WindowUtil.openWin(self.windowName, Lua_WinParam.ACTION_CLOSE);
end

function Lua_DownLoadRewardWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onDownLoading);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DownLoadRewardItem = class("Lua_DownLoadRewardItem", Lua_ItemIconCell);
function Lua_DownLoadRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.94, 0.94);
end